#include <iostream>

#include "ParGraph.hpp"
#include "PG_owner_computes_graph.hpp"

using namespace ParGraph;

typedef property< edge_capacity_tag, unsigned int,
        property< edge_flow_tag, unsigned int > > network_edges_property_type;
typedef property< edge_capacity_tag, unsigned int,
	property< edge_flag1_tag, bool,
	property< edge_reference_tag, EdgeID_t,
        property< edge_flow_tag, unsigned int > > > > residual_edges_property_type;
typedef EdgeList< network_edges_property_type,
		  directed_in_out_edges_type > network_edgelist_type;
typedef EdgeList< residual_edges_property_type,
		  directed_in_out_edges_type > residual_edgelist_type;
typedef property< vertex_potential_tag, unsigned int,
	property< vertex_level_tag, unsigned int,
        property< edgelist1_tag, network_edgelist_type,
	property< edgelist_residual_tag, residual_edgelist_type > > > >
            vertex_property_type;

typedef OwnerComputesGraph<vertex_property_type> Graph;
typedef Graph::VertexIterator VertexIter;
typedef Graph::VertexSet::iterator VertexSetIter;
typedef Graph::KnownVertex Vertex;
typedef network_edgelist_type::Edge NetworkEdge;
typedef residual_edgelist_type::Edge ResidualEdge;

void print();
void dinic_read_graph( int argc, char **argv );

extern Graph *g;
extern Graph::VertexSetHandle set_s_vertex, set_t_vertex;
extern EdgeMap< edgelist1_tag, Graph > network_edges;
